import { Option } from './option';
import { IOption } from './option.interface';
export declare class OptionList {
    private _options;
    private _highlightedOption;
    private _hasShown;
    private _hasSelected;
    get hasShown(): boolean;
    get hasSelected(): boolean;
    constructor(options: Array<IOption>);
    /** Options. **/
    get options(): Array<Option>;
    getOptionsByValue(value: string): Array<Option>;
    /** Value. **/
    get value(): Array<string>;
    set value(v: Array<string>);
    /** Selection. **/
    get selection(): Array<Option>;
    select(option: Option, multiple: boolean): void;
    deselect(option: Option): void;
    clearSelection(): void;
    private updateHasSelected;
    /** Filter. **/
    get filtered(): Array<Option>;
    get filteredEnabled(): Array<Option>;
    filter(term: string): boolean;
    private resetFilter;
    /** Highlight. **/
    get highlightedOption(): Option;
    highlight(): void;
    highlightOption(option: Option): void;
    highlightNextOption(): void;
    highlightPreviousOption(): void;
    private clearHighlightedOption;
    private getHighlightedIndexFromList;
    getHighlightedIndex(): number;
    /** Util. **/
    hasShownSelected(): boolean;
    private getFirstShown;
    private getFirstShownSelected;
    static equalValues(v0: Array<string>, v1: Array<string>): boolean;
}
